// 002 u_50_excel_server
// 03 dec 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_50_excel_server;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Grids, DBGrids, DB, DBTables, Spin, ExtCtrls,
  OleServer, Excel97;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    create_application_: TButton;
    toggle_excel_visible_: TButton;
    Panel4: TPanel;
    Panel5: TPanel;
    close_exce_: TButton;
    ExcelApplication1: TExcelApplication;
    add_data_: TButton;
    ExcelWorkbook1: TExcelWorkbook;
    ExcelWorksheet1: TExcelWorksheet;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure create_application_Click(Sender: TObject);
    procedure toggle_excel_visible_Click(Sender: TObject);
    procedure close_exce_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure analyze_Click(Sender: TObject);
    procedure add_data_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses ComObj, Variants
      // , ActiveX

      , u_types_constants, u_c_log, u_c_display
      , u_file, u_dir
      , u_strings
      , u_handle_files_in_dirs
      ;


    {$R *.DFM}

    const k_initial_directory= 'C:\programs\fr\com\excel\_data';

          k_extension= '.xls';
          k_file_name= 'annuaire.xls';

          k_my_sheet= 'my_sheet';
          k_save_file_name= 'my_sheet.xls';

    var g_path: String= k_initial_directory;
        g_file_name: String= k_file_name;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
      end;

    // -- actions

    var g_visible: Boolean= False;

    procedure TForm1.create_application_Click(Sender: TObject);
        // -- Connect to the server TExcelApplication
      begin
        ExcelApplication1.Connect;
        g_visible:= Not g_visible;
        ExcelApplication1.Visible[0]:= g_visible;

        // -- add new workbook and connect WB wrapper

        ExcelWorkBook1.ConnectTo(ExcelApplication1.Workbooks.Add(
            xlWBATWorksheet, 0));

        // -- connect to sheet 1
        ExcelWorkSheet1.ConnectTo(ExcelWorkBook1.Worksheets[1] as _Worksheet);

        // -- select the first worksheet
        (ExcelWorkBook1.Worksheets[1] as _WorkSheet).Select(EmptyParam, 0);
      end; // create_application_Click

    procedure TForm1.toggle_excel_visible_Click(Sender: TObject);
        // -- togle the visibility of Excel
      begin
        g_visible:= Not g_visible;
        ExcelApplication1.Visible[0]:= g_visible;
      end; // excel_visible_Click

    procedure TForm1.analyze_Click(Sender: TObject);
      var l_c_ole_worksheet: Variant;
          l_workbook_index: Integer;
          l_sheet_index: Integer;
      begin
        display('> analyze_Click');
        for l_workbook_index:= 1 to ExcelApplication1.Workbooks.Count do
        begin
          display('Workbook: ' + ExcelApplication1.Workbooks[l_workbook_index].Name);
          for l_sheet_index:= 1 to ExcelApplication1.Workbooks[l_workbook_index].Sheets.Count do
          begin
            l_c_ole_worksheet:= ExcelApplication1.Workbooks[l_workbook_index].Sheets[l_sheet_index];
            display('  Sheet: ' + l_c_ole_worksheet.Name);
          end;
        end;
        display('< analyze');
      end; // analyze_Click

    procedure TForm1.close_exce_Click(Sender: TObject);
      begin
        ExcelApplication1.Quit;
        // ExcelApplication1:= Unassigned;
      end; // close_exce_Click

    procedure TForm1.add_data_Click(Sender: TObject);
      const k_row_count= 6;
            k_column_count= 9;
      var l_row_count, l_column_count: Integer;
          l_v_data_array: Variant;

      procedure initialize_variant_array;
          // -- fill a Variant array with some data
        var l_row, l_column: Integer;
        begin
          l_row_count:= k_row_count;
          l_column_count:= k_column_count;

          l_v_data_array := VarArrayCreate([0, l_row_count - 1, 0, l_column_count - 1], VarOleStr);

          for l_row:= 0 to l_row_count- 1 do
            for l_column:= 0 to l_column_count- 1 do
              l_v_data_array[l_row, l_column]:= 3+ Random(5);
        end; // initialize_variant_array

      begin // add_data_Click
        initialize_variant_array;

        // -- Assign the Delphi Variant Matrix to the Variant associated with the WorkSheet
        ExcelWorkSheet1.Range['A1', ExcelWorkSheet1.Cells.Item[k_row_count, k_column_count]].Value := l_v_data_array;

        // -- Customise the WorkSheet
        ExcelWorkSheet1.Name := 'Customers';
        ExcelWorkSheet1.Columns.Font.Bold := True;
        ExcelWorkSheet1.Columns.HorizontalAlignment := xlRight;
        ExcelWorkSheet1.Columns.ColumnWidth := 4;

        // -- Customise the first entire Column
        ExcelWorkSheet1.Range['A1', 'A6'].Font.Color := clBlue;
        ExcelWorkSheet1.Range['A1', 'A6'].HorizontalAlignment := xlHAlignLeft;
        ExcelWorkSheet1.Range['A1', 'A6'].ColumnWidth := 7;

        // -- Unassign the Delphi Variant array
        l_v_data_array:= Unassigned;
      end; // add_data_Click

end.

